


<!DOCTYPE html>
<html>
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
    
    
    <meta http-equiv="X-UA-Compatible" content="IE=emulateIE7" />
    <title>Coverage for /private/tmp/im/impacket/impacket/helper.py: 94%</title>
    <link rel="stylesheet" href="style.css" type="text/css">
    
    <script type="text/javascript" src="jquery.min.js"></script>
    <script type="text/javascript" src="jquery.hotkeys.js"></script>
    <script type="text/javascript" src="jquery.isonscreen.js"></script>
    <script type="text/javascript" src="coverage_html.js"></script>
    <script type="text/javascript">
        jQuery(document).ready(coverage.pyfile_ready);
    </script>
</head>
<body class="pyfile">

<div id="header">
    <div class="content">
        <h1>Coverage for <b>/private/tmp/im/impacket/impacket/helper.py</b> :
            <span class="pc_cov">94%</span>
        </h1>

        <img id="keyboard_icon" src="keybd_closed.png" alt="Show keyboard shortcuts" />

        <h2 class="stats">
            96 statements &nbsp;
            <span class="run hide_run shortkey_r button_toggle_run">93 run</span>
            <span class="mis shortkey_m button_toggle_mis">3 missing</span>
            <span class="exc shortkey_x button_toggle_exc">0 excluded</span>

            
                <span class="par run hide_run shortkey_p button_toggle_par">2 partial</span>
            
        </h2>
    </div>
</div>

<div class="help_panel">
    <img id="panel_icon" src="keybd_open.png" alt="Hide keyboard shortcuts" />
    <p class="legend">Hot-keys on this page</p>
    <div>
    <p class="keyhelp">
        <span class="key">r</span>
        <span class="key">m</span>
        <span class="key">x</span>
        <span class="key">p</span> &nbsp; toggle line displays
    </p>
    <p class="keyhelp">
        <span class="key">j</span>
        <span class="key">k</span> &nbsp; next/prev highlighted chunk
    </p>
    <p class="keyhelp">
        <span class="key">0</span> &nbsp; (zero) top of page
    </p>
    <p class="keyhelp">
        <span class="key">1</span> &nbsp; (one) first highlighted chunk
    </p>
    </div>
</div>

<div id="source">
    <table>
        <tr>
            <td class="linenos">
<p id="n1" class="pln"><a href="#n1">1</a></p>
<p id="n2" class="pln"><a href="#n2">2</a></p>
<p id="n3" class="pln"><a href="#n3">3</a></p>
<p id="n4" class="pln"><a href="#n4">4</a></p>
<p id="n5" class="pln"><a href="#n5">5</a></p>
<p id="n6" class="pln"><a href="#n6">6</a></p>
<p id="n7" class="pln"><a href="#n7">7</a></p>
<p id="n8" class="pln"><a href="#n8">8</a></p>
<p id="n9" class="pln"><a href="#n9">9</a></p>
<p id="n10" class="pln"><a href="#n10">10</a></p>
<p id="n11" class="pln"><a href="#n11">11</a></p>
<p id="n12" class="pln"><a href="#n12">12</a></p>
<p id="n13" class="pln"><a href="#n13">13</a></p>
<p id="n14" class="stm run hide_run"><a href="#n14">14</a></p>
<p id="n15" class="stm run hide_run"><a href="#n15">15</a></p>
<p id="n16" class="stm run hide_run"><a href="#n16">16</a></p>
<p id="n17" class="pln"><a href="#n17">17</a></p>
<p id="n18" class="stm run hide_run"><a href="#n18">18</a></p>
<p id="n19" class="pln"><a href="#n19">19</a></p>
<p id="n20" class="pln"><a href="#n20">20</a></p>
<p id="n21" class="stm run hide_run"><a href="#n21">21</a></p>
<p id="n22" class="stm run hide_run"><a href="#n22">22</a></p>
<p id="n23" class="stm run hide_run"><a href="#n23">23</a></p>
<p id="n24" class="stm run hide_run"><a href="#n24">24</a></p>
<p id="n25" class="pln"><a href="#n25">25</a></p>
<p id="n26" class="stm run hide_run"><a href="#n26">26</a></p>
<p id="n27" class="pln"><a href="#n27">27</a></p>
<p id="n28" class="stm run hide_run"><a href="#n28">28</a></p>
<p id="n29" class="stm run hide_run"><a href="#n29">29</a></p>
<p id="n30" class="stm run hide_run"><a href="#n30">30</a></p>
<p id="n31" class="pln"><a href="#n31">31</a></p>
<p id="n32" class="stm run hide_run"><a href="#n32">32</a></p>
<p id="n33" class="stm run hide_run"><a href="#n33">33</a></p>
<p id="n34" class="stm run hide_run"><a href="#n34">34</a></p>
<p id="n35" class="stm run hide_run"><a href="#n35">35</a></p>
<p id="n36" class="stm run hide_run"><a href="#n36">36</a></p>
<p id="n37" class="stm run hide_run"><a href="#n37">37</a></p>
<p id="n38" class="pln"><a href="#n38">38</a></p>
<p id="n39" class="stm run hide_run"><a href="#n39">39</a></p>
<p id="n40" class="stm run hide_run"><a href="#n40">40</a></p>
<p id="n41" class="stm run hide_run"><a href="#n41">41</a></p>
<p id="n42" class="stm run hide_run"><a href="#n42">42</a></p>
<p id="n43" class="stm run hide_run"><a href="#n43">43</a></p>
<p id="n44" class="pln"><a href="#n44">44</a></p>
<p id="n45" class="stm run hide_run"><a href="#n45">45</a></p>
<p id="n46" class="pln"><a href="#n46">46</a></p>
<p id="n47" class="stm run hide_run"><a href="#n47">47</a></p>
<p id="n48" class="stm run hide_run"><a href="#n48">48</a></p>
<p id="n49" class="stm run hide_run"><a href="#n49">49</a></p>
<p id="n50" class="stm run hide_run"><a href="#n50">50</a></p>
<p id="n51" class="stm run hide_run"><a href="#n51">51</a></p>
<p id="n52" class="pln"><a href="#n52">52</a></p>
<p id="n53" class="stm run hide_run"><a href="#n53">53</a></p>
<p id="n54" class="stm run hide_run"><a href="#n54">54</a></p>
<p id="n55" class="pln"><a href="#n55">55</a></p>
<p id="n56" class="stm run hide_run"><a href="#n56">56</a></p>
<p id="n57" class="stm run hide_run"><a href="#n57">57</a></p>
<p id="n58" class="stm par run hide_run"><a href="#n58">58</a></p>
<p id="n59" class="stm mis"><a href="#n59">59</a></p>
<p id="n60" class="pln"><a href="#n60">60</a></p>
<p id="n61" class="stm run hide_run"><a href="#n61">61</a></p>
<p id="n62" class="pln"><a href="#n62">62</a></p>
<p id="n63" class="stm run hide_run"><a href="#n63">63</a></p>
<p id="n64" class="pln"><a href="#n64">64</a></p>
<p id="n65" class="stm run hide_run"><a href="#n65">65</a></p>
<p id="n66" class="pln"><a href="#n66">66</a></p>
<p id="n67" class="stm run hide_run"><a href="#n67">67</a></p>
<p id="n68" class="stm run hide_run"><a href="#n68">68</a></p>
<p id="n69" class="pln"><a href="#n69">69</a></p>
<p id="n70" class="stm run hide_run"><a href="#n70">70</a></p>
<p id="n71" class="stm run hide_run"><a href="#n71">71</a></p>
<p id="n72" class="pln"><a href="#n72">72</a></p>
<p id="n73" class="stm run hide_run"><a href="#n73">73</a></p>
<p id="n74" class="stm run hide_run"><a href="#n74">74</a></p>
<p id="n75" class="pln"><a href="#n75">75</a></p>
<p id="n76" class="stm run hide_run"><a href="#n76">76</a></p>
<p id="n77" class="stm run hide_run"><a href="#n77">77</a></p>
<p id="n78" class="stm run hide_run"><a href="#n78">78</a></p>
<p id="n79" class="stm run hide_run"><a href="#n79">79</a></p>
<p id="n80" class="pln"><a href="#n80">80</a></p>
<p id="n81" class="stm run hide_run"><a href="#n81">81</a></p>
<p id="n82" class="stm run hide_run"><a href="#n82">82</a></p>
<p id="n83" class="pln"><a href="#n83">83</a></p>
<p id="n84" class="stm run hide_run"><a href="#n84">84</a></p>
<p id="n85" class="stm run hide_run"><a href="#n85">85</a></p>
<p id="n86" class="pln"><a href="#n86">86</a></p>
<p id="n87" class="stm run hide_run"><a href="#n87">87</a></p>
<p id="n88" class="stm run hide_run"><a href="#n88">88</a></p>
<p id="n89" class="stm run hide_run"><a href="#n89">89</a></p>
<p id="n90" class="stm run hide_run"><a href="#n90">90</a></p>
<p id="n91" class="pln"><a href="#n91">91</a></p>
<p id="n92" class="stm run hide_run"><a href="#n92">92</a></p>
<p id="n93" class="stm run hide_run"><a href="#n93">93</a></p>
<p id="n94" class="pln"><a href="#n94">94</a></p>
<p id="n95" class="stm run hide_run"><a href="#n95">95</a></p>
<p id="n96" class="stm run hide_run"><a href="#n96">96</a></p>
<p id="n97" class="pln"><a href="#n97">97</a></p>
<p id="n98" class="stm run hide_run"><a href="#n98">98</a></p>
<p id="n99" class="stm run hide_run"><a href="#n99">99</a></p>
<p id="n100" class="stm run hide_run"><a href="#n100">100</a></p>
<p id="n101" class="pln"><a href="#n101">101</a></p>
<p id="n102" class="stm run hide_run"><a href="#n102">102</a></p>
<p id="n103" class="stm run hide_run"><a href="#n103">103</a></p>
<p id="n104" class="pln"><a href="#n104">104</a></p>
<p id="n105" class="stm run hide_run"><a href="#n105">105</a></p>
<p id="n106" class="stm run hide_run"><a href="#n106">106</a></p>
<p id="n107" class="pln"><a href="#n107">107</a></p>
<p id="n108" class="stm run hide_run"><a href="#n108">108</a></p>
<p id="n109" class="pln"><a href="#n109">109</a></p>
<p id="n110" class="stm run hide_run"><a href="#n110">110</a></p>
<p id="n111" class="stm run hide_run"><a href="#n111">111</a></p>
<p id="n112" class="pln"><a href="#n112">112</a></p>
<p id="n113" class="stm run hide_run"><a href="#n113">113</a></p>
<p id="n114" class="stm run hide_run"><a href="#n114">114</a></p>
<p id="n115" class="pln"><a href="#n115">115</a></p>
<p id="n116" class="pln"><a href="#n116">116</a></p>
<p id="n117" class="stm run hide_run"><a href="#n117">117</a></p>
<p id="n118" class="stm run hide_run"><a href="#n118">118</a></p>
<p id="n119" class="stm run hide_run"><a href="#n119">119</a></p>
<p id="n120" class="stm run hide_run"><a href="#n120">120</a></p>
<p id="n121" class="stm par run hide_run"><a href="#n121">121</a></p>
<p id="n122" class="stm run hide_run"><a href="#n122">122</a></p>
<p id="n123" class="stm run hide_run"><a href="#n123">123</a></p>
<p id="n124" class="stm run hide_run"><a href="#n124">124</a></p>
<p id="n125" class="stm run hide_run"><a href="#n125">125</a></p>
<p id="n126" class="stm run hide_run"><a href="#n126">126</a></p>
<p id="n127" class="pln"><a href="#n127">127</a></p>
<p id="n128" class="stm run hide_run"><a href="#n128">128</a></p>
<p id="n129" class="pln"><a href="#n129">129</a></p>
<p id="n130" class="stm run hide_run"><a href="#n130">130</a></p>
<p id="n131" class="stm mis"><a href="#n131">131</a></p>
<p id="n132" class="stm run hide_run"><a href="#n132">132</a></p>
<p id="n133" class="pln"><a href="#n133">133</a></p>
<p id="n134" class="stm mis"><a href="#n134">134</a></p>
<p id="n135" class="pln"><a href="#n135">135</a></p>
<p id="n136" class="pln"><a href="#n136">136</a></p>
<p id="n137" class="pln"><a href="#n137">137</a></p>
<p id="n138" class="pln"><a href="#n138">138</a></p>
<p id="n139" class="pln"><a href="#n139">139</a></p>
<p id="n140" class="stm run hide_run"><a href="#n140">140</a></p>
<p id="n141" class="stm run hide_run"><a href="#n141">141</a></p>
<p id="n142" class="pln"><a href="#n142">142</a></p>
<p id="n143" class="stm run hide_run"><a href="#n143">143</a></p>
<p id="n144" class="pln"><a href="#n144">144</a></p>
<p id="n145" class="stm run hide_run"><a href="#n145">145</a></p>
<p id="n146" class="stm run hide_run"><a href="#n146">146</a></p>
<p id="n147" class="stm run hide_run"><a href="#n147">147</a></p>
<p id="n148" class="stm run hide_run"><a href="#n148">148</a></p>
<p id="n149" class="stm run hide_run"><a href="#n149">149</a></p>
<p id="n150" class="stm run hide_run"><a href="#n150">150</a></p>

            </td>
            <td class="text">
<p id="t1" class="pln"><span class="com"># SECUREAUTH LABS. Copyright 2018 SecureAuth Corporation. All rights reserved.</span><span class="strut">&nbsp;</span></p>
<p id="t2" class="pln"><span class="com">#</span><span class="strut">&nbsp;</span></p>
<p id="t3" class="pln"><span class="com"># This software is provided under under a slightly modified version</span><span class="strut">&nbsp;</span></p>
<p id="t4" class="pln"><span class="com"># of the Apache Software License. See the accompanying LICENSE file</span><span class="strut">&nbsp;</span></p>
<p id="t5" class="pln"><span class="com"># for more information.</span><span class="strut">&nbsp;</span></p>
<p id="t6" class="pln"><span class="com">#</span><span class="strut">&nbsp;</span></p>
<p id="t7" class="pln"><span class="com"># Description:</span><span class="strut">&nbsp;</span></p>
<p id="t8" class="pln"><span class="com">#  Helper used to build ProtocolPackets</span><span class="strut">&nbsp;</span></p>
<p id="t9" class="pln"><span class="com">#</span><span class="strut">&nbsp;</span></p>
<p id="t10" class="pln"><span class="com"># Author:</span><span class="strut">&nbsp;</span></p>
<p id="t11" class="pln"><span class="com"># Aureliano Calvo</span><span class="strut">&nbsp;</span></p>
<p id="t12" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t13" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t14" class="stm run hide_run"><span class="key">import</span> <span class="nam">struct</span><span class="strut">&nbsp;</span></p>
<p id="t15" class="stm run hide_run"><span class="key">import</span> <span class="nam">functools</span><span class="strut">&nbsp;</span></p>
<p id="t16" class="stm run hide_run"><span class="key">from</span> <span class="nam">six</span> <span class="key">import</span> <span class="nam">add_metaclass</span><span class="strut">&nbsp;</span></p>
<p id="t17" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t18" class="stm run hide_run"><span class="key">import</span> <span class="nam">impacket</span><span class="op">.</span><span class="nam">ImpactPacket</span> <span class="key">as</span> <span class="nam">ip</span><span class="strut">&nbsp;</span></p>
<p id="t19" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t20" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t21" class="stm run hide_run"><span class="key">def</span> <span class="nam">rebind</span><span class="op">(</span><span class="nam">f</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t22" class="stm run hide_run">    <span class="nam">functools</span><span class="op">.</span><span class="nam">wraps</span><span class="op">(</span><span class="nam">f</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t23" class="stm run hide_run">    <span class="key">def</span> <span class="nam">rebinder</span><span class="op">(</span><span class="op">*</span><span class="nam">args</span><span class="op">,</span> <span class="op">**</span><span class="nam">kwargs</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t24" class="stm run hide_run">        <span class="key">return</span> <span class="nam">f</span><span class="op">(</span><span class="op">*</span><span class="nam">args</span><span class="op">,</span> <span class="op">**</span><span class="nam">kwargs</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t25" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t26" class="stm run hide_run">    <span class="key">return</span> <span class="nam">rebinder</span><span class="strut">&nbsp;</span></p>
<p id="t27" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t28" class="stm run hide_run"><span class="key">class</span> <span class="nam">Field</span><span class="op">(</span><span class="nam">object</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t29" class="stm run hide_run">    <span class="key">def</span> <span class="nam">__init__</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">index</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t30" class="stm run hide_run">        <span class="nam">self</span><span class="op">.</span><span class="nam">index</span> <span class="op">=</span> <span class="nam">index</span><span class="strut">&nbsp;</span></p>
<p id="t31" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t32" class="stm run hide_run">    <span class="key">def</span> <span class="nam">__call__</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">k</span><span class="op">,</span> <span class="nam">d</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t33" class="stm run hide_run">        <span class="nam">getter</span> <span class="op">=</span> <span class="nam">rebind</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">getter</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t34" class="stm run hide_run">        <span class="nam">getter_name</span> <span class="op">=</span> <span class="str">"get_"</span> <span class="op">+</span> <span class="nam">k</span><span class="strut">&nbsp;</span></p>
<p id="t35" class="stm run hide_run">        <span class="nam">getter</span><span class="op">.</span><span class="nam">__name__</span> <span class="op">=</span> <span class="nam">getter_name</span><span class="strut">&nbsp;</span></p>
<p id="t36" class="stm run hide_run">        <span class="nam">getter</span><span class="op">.</span><span class="nam">__doc__</span> <span class="op">=</span> <span class="str">"Get the %s field"</span> <span class="op">%</span> <span class="nam">k</span><span class="strut">&nbsp;</span></p>
<p id="t37" class="stm run hide_run">        <span class="nam">d</span><span class="op">[</span><span class="nam">getter_name</span><span class="op">]</span> <span class="op">=</span> <span class="nam">getter</span><span class="strut">&nbsp;</span></p>
<p id="t38" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t39" class="stm run hide_run">        <span class="nam">setter</span> <span class="op">=</span> <span class="nam">rebind</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">setter</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t40" class="stm run hide_run">        <span class="nam">setter_name</span> <span class="op">=</span> <span class="str">"set_"</span> <span class="op">+</span> <span class="nam">k</span><span class="strut">&nbsp;</span></p>
<p id="t41" class="stm run hide_run">        <span class="nam">setter</span><span class="op">.</span><span class="nam">__name__</span> <span class="op">=</span> <span class="nam">setter_name</span><span class="strut">&nbsp;</span></p>
<p id="t42" class="stm run hide_run">        <span class="nam">setter</span><span class="op">.</span><span class="nam">__doc__</span> <span class="op">=</span> <span class="str">"Set the %s field"</span> <span class="op">%</span> <span class="nam">k</span><span class="strut">&nbsp;</span></p>
<p id="t43" class="stm run hide_run">        <span class="nam">d</span><span class="op">[</span><span class="str">"set_"</span> <span class="op">+</span> <span class="nam">k</span><span class="op">]</span> <span class="op">=</span> <span class="nam">setter</span><span class="strut">&nbsp;</span></p>
<p id="t44" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t45" class="stm run hide_run">        <span class="nam">d</span><span class="op">[</span><span class="nam">k</span><span class="op">]</span> <span class="op">=</span> <span class="nam">property</span><span class="op">(</span><span class="nam">getter</span><span class="op">,</span> <span class="nam">setter</span><span class="op">,</span> <span class="nam">doc</span><span class="op">=</span><span class="str">"%s property"</span> <span class="op">%</span> <span class="nam">k</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t46" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t47" class="stm run hide_run"><span class="key">class</span> <span class="nam">Bit</span><span class="op">(</span><span class="nam">Field</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t48" class="stm run hide_run">    <span class="key">def</span> <span class="nam">__init__</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">index</span><span class="op">,</span> <span class="nam">bit_number</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t49" class="stm run hide_run">        <span class="nam">Field</span><span class="op">.</span><span class="nam">__init__</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">index</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t50" class="stm run hide_run">        <span class="nam">self</span><span class="op">.</span><span class="nam">mask</span> <span class="op">=</span> <span class="num">2</span> <span class="op">**</span> <span class="nam">bit_number</span><span class="strut">&nbsp;</span></p>
<p id="t51" class="stm run hide_run">        <span class="nam">self</span><span class="op">.</span><span class="nam">off_mask</span> <span class="op">=</span> <span class="op">(</span><span class="op">~</span><span class="nam">self</span><span class="op">.</span><span class="nam">mask</span><span class="op">)</span> <span class="op">&amp;</span> <span class="num">0xff</span><span class="strut">&nbsp;</span></p>
<p id="t52" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t53" class="stm run hide_run">    <span class="key">def</span> <span class="nam">getter</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">o</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t54" class="stm run hide_run">        <span class="key">return</span> <span class="op">(</span><span class="nam">o</span><span class="op">.</span><span class="nam">header</span><span class="op">.</span><span class="nam">get_byte</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">index</span><span class="op">)</span> <span class="op">&amp;</span> <span class="nam">self</span><span class="op">.</span><span class="nam">mask</span><span class="op">)</span> <span class="op">!=</span> <span class="num">0</span><span class="strut">&nbsp;</span></p>
<p id="t55" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t56" class="stm run hide_run">    <span class="key">def</span> <span class="nam">setter</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">o</span><span class="op">,</span> <span class="nam">value</span><span class="op">=</span><span class="key">True</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t57" class="stm run hide_run">        <span class="nam">b</span> <span class="op">=</span> <span class="nam">o</span><span class="op">.</span><span class="nam">header</span><span class="op">.</span><span class="nam">get_byte</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">index</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t58" class="stm par run hide_run"><span class="annotate short">58&#x202F;&#x219B;&#x202F;59</span><span class="annotate long">line 58 didn't jump to line 59, because the condition on line 58 was never true</span>        <span class="key">if</span> <span class="nam">value</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t59" class="stm mis">            <span class="nam">b</span> <span class="op">|=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">mask</span><span class="strut">&nbsp;</span></p>
<p id="t60" class="pln">        <span class="key">else</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t61" class="stm run hide_run">            <span class="nam">b</span> <span class="op">&amp;=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">off_mask</span><span class="strut">&nbsp;</span></p>
<p id="t62" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t63" class="stm run hide_run">        <span class="nam">o</span><span class="op">.</span><span class="nam">header</span><span class="op">.</span><span class="nam">set_byte</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">index</span><span class="op">,</span> <span class="nam">b</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t64" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t65" class="stm run hide_run"><span class="key">class</span> <span class="nam">Byte</span><span class="op">(</span><span class="nam">Field</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t66" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t67" class="stm run hide_run">    <span class="key">def</span> <span class="nam">__init__</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">index</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t68" class="stm run hide_run">        <span class="nam">Field</span><span class="op">.</span><span class="nam">__init__</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">index</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t69" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t70" class="stm run hide_run">    <span class="key">def</span> <span class="nam">getter</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">o</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t71" class="stm run hide_run">        <span class="key">return</span> <span class="nam">o</span><span class="op">.</span><span class="nam">header</span><span class="op">.</span><span class="nam">get_byte</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">index</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t72" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t73" class="stm run hide_run">    <span class="key">def</span> <span class="nam">setter</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">o</span><span class="op">,</span> <span class="nam">value</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t74" class="stm run hide_run">        <span class="nam">o</span><span class="op">.</span><span class="nam">header</span><span class="op">.</span><span class="nam">set_byte</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">index</span><span class="op">,</span> <span class="nam">value</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t75" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t76" class="stm run hide_run"><span class="key">class</span> <span class="nam">Word</span><span class="op">(</span><span class="nam">Field</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t77" class="stm run hide_run">    <span class="key">def</span> <span class="nam">__init__</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">index</span><span class="op">,</span> <span class="nam">order</span><span class="op">=</span><span class="str">"!"</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t78" class="stm run hide_run">        <span class="nam">Field</span><span class="op">.</span><span class="nam">__init__</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">index</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t79" class="stm run hide_run">        <span class="nam">self</span><span class="op">.</span><span class="nam">order</span> <span class="op">=</span> <span class="nam">order</span><span class="strut">&nbsp;</span></p>
<p id="t80" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t81" class="stm run hide_run">    <span class="key">def</span> <span class="nam">getter</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">o</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t82" class="stm run hide_run">        <span class="key">return</span> <span class="nam">o</span><span class="op">.</span><span class="nam">header</span><span class="op">.</span><span class="nam">get_word</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">index</span><span class="op">,</span> <span class="nam">self</span><span class="op">.</span><span class="nam">order</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t83" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t84" class="stm run hide_run">    <span class="key">def</span> <span class="nam">setter</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">o</span><span class="op">,</span> <span class="nam">value</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t85" class="stm run hide_run">        <span class="nam">o</span><span class="op">.</span><span class="nam">header</span><span class="op">.</span><span class="nam">set_word</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">index</span><span class="op">,</span> <span class="nam">value</span><span class="op">,</span> <span class="nam">self</span><span class="op">.</span><span class="nam">order</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t86" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t87" class="stm run hide_run"><span class="key">class</span> <span class="nam">Long</span><span class="op">(</span><span class="nam">Field</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t88" class="stm run hide_run">    <span class="key">def</span> <span class="nam">__init__</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">index</span><span class="op">,</span> <span class="nam">order</span><span class="op">=</span><span class="str">"!"</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t89" class="stm run hide_run">        <span class="nam">Field</span><span class="op">.</span><span class="nam">__init__</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">index</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t90" class="stm run hide_run">        <span class="nam">self</span><span class="op">.</span><span class="nam">order</span> <span class="op">=</span> <span class="nam">order</span><span class="strut">&nbsp;</span></p>
<p id="t91" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t92" class="stm run hide_run">    <span class="key">def</span> <span class="nam">getter</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">o</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t93" class="stm run hide_run">        <span class="key">return</span> <span class="nam">o</span><span class="op">.</span><span class="nam">header</span><span class="op">.</span><span class="nam">get_long</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">index</span><span class="op">,</span> <span class="nam">self</span><span class="op">.</span><span class="nam">order</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t94" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t95" class="stm run hide_run">    <span class="key">def</span> <span class="nam">setter</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">o</span><span class="op">,</span> <span class="nam">value</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t96" class="stm run hide_run">        <span class="nam">o</span><span class="op">.</span><span class="nam">header</span><span class="op">.</span><span class="nam">set_long</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">index</span><span class="op">,</span> <span class="nam">value</span><span class="op">,</span> <span class="nam">self</span><span class="op">.</span><span class="nam">order</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t97" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t98" class="stm run hide_run"><span class="key">class</span> <span class="nam">ThreeBytesBigEndian</span><span class="op">(</span><span class="nam">Field</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t99" class="stm run hide_run">    <span class="key">def</span> <span class="nam">__init__</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">index</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t100" class="stm run hide_run">        <span class="nam">Field</span><span class="op">.</span><span class="nam">__init__</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">index</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t101" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t102" class="stm run hide_run">    <span class="key">def</span> <span class="nam">getter</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">o</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t103" class="stm run hide_run">        <span class="nam">b</span><span class="op">=</span><span class="nam">o</span><span class="op">.</span><span class="nam">header</span><span class="op">.</span><span class="nam">get_bytes</span><span class="op">(</span><span class="op">)</span><span class="op">[</span><span class="nam">self</span><span class="op">.</span><span class="nam">index</span><span class="op">:</span><span class="nam">self</span><span class="op">.</span><span class="nam">index</span><span class="op">+</span><span class="num">3</span><span class="op">]</span><span class="op">.</span><span class="nam">tostring</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t104" class="pln">        <span class="com">#unpack requires a string argument of length 4 and b is 3 bytes long</span><span class="strut">&nbsp;</span></p>
<p id="t105" class="stm run hide_run">        <span class="op">(</span><span class="nam">value</span><span class="op">,</span><span class="op">)</span><span class="op">=</span><span class="nam">struct</span><span class="op">.</span><span class="nam">unpack</span><span class="op">(</span><span class="str">'!L'</span><span class="op">,</span> <span class="str">b'\x00'</span><span class="op">+</span><span class="nam">b</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t106" class="stm run hide_run">        <span class="key">return</span> <span class="nam">value</span><span class="strut">&nbsp;</span></p>
<p id="t107" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t108" class="stm run hide_run">    <span class="key">def</span> <span class="nam">setter</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">o</span><span class="op">,</span> <span class="nam">value</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t109" class="pln">        <span class="com"># clear the bits</span><span class="strut">&nbsp;</span></p>
<p id="t110" class="stm run hide_run">        <span class="nam">mask</span> <span class="op">=</span> <span class="op">(</span><span class="op">(</span><span class="op">~</span><span class="num">0xFFFFFF00</span><span class="op">)</span> <span class="op">&amp;</span> <span class="num">0xFF</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t111" class="stm run hide_run">        <span class="nam">masked</span> <span class="op">=</span> <span class="nam">o</span><span class="op">.</span><span class="nam">header</span><span class="op">.</span><span class="nam">get_long</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">index</span><span class="op">,</span> <span class="str">">"</span><span class="op">)</span> <span class="op">&amp;</span> <span class="nam">mask</span><span class="strut">&nbsp;</span></p>
<p id="t112" class="pln">        <span class="com"># set the bits </span><span class="strut">&nbsp;</span></p>
<p id="t113" class="stm run hide_run">        <span class="nam">nb</span> <span class="op">=</span> <span class="nam">masked</span> <span class="op">|</span> <span class="op">(</span><span class="op">(</span><span class="nam">value</span> <span class="op">&amp;</span> <span class="num">0x00FFFFFF</span><span class="op">)</span> <span class="op">&lt;&lt;</span> <span class="num">8</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t114" class="stm run hide_run">        <span class="nam">o</span><span class="op">.</span><span class="nam">header</span><span class="op">.</span><span class="nam">set_long</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">index</span><span class="op">,</span> <span class="nam">nb</span><span class="op">,</span> <span class="str">">"</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t115" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t116" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t117" class="stm run hide_run"><span class="key">class</span> <span class="nam">ProtocolPacketMetaklass</span><span class="op">(</span><span class="nam">type</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t118" class="stm run hide_run">    <span class="key">def</span> <span class="nam">__new__</span><span class="op">(</span><span class="nam">cls</span><span class="op">,</span> <span class="nam">name</span><span class="op">,</span> <span class="nam">bases</span><span class="op">,</span> <span class="nam">d</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t119" class="stm run hide_run">        <span class="nam">d</span><span class="op">[</span><span class="str">"_fields"</span><span class="op">]</span> <span class="op">=</span> <span class="op">[</span><span class="op">]</span><span class="strut">&nbsp;</span></p>
<p id="t120" class="stm run hide_run">        <span class="nam">items</span> <span class="op">=</span> <span class="nam">list</span><span class="op">(</span><span class="nam">d</span><span class="op">.</span><span class="nam">items</span><span class="op">(</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t121" class="stm par run hide_run"><span class="annotate short">121&#x202F;&#x219B;&#x202F;123</span><span class="annotate long">line 121 didn't jump to line 123, because the condition on line 121 was never false</span>        <span class="key">if</span> <span class="key">not</span> <span class="nam">object</span> <span class="key">in</span> <span class="nam">bases</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t122" class="stm run hide_run">            <span class="nam">bases</span> <span class="op">+=</span> <span class="op">(</span><span class="nam">object</span><span class="op">,</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t123" class="stm run hide_run">        <span class="key">for</span> <span class="nam">k</span><span class="op">,</span><span class="nam">v</span> <span class="key">in</span> <span class="nam">items</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t124" class="stm run hide_run">            <span class="key">if</span> <span class="nam">isinstance</span><span class="op">(</span><span class="nam">v</span><span class="op">,</span> <span class="nam">Field</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t125" class="stm run hide_run">                <span class="nam">d</span><span class="op">[</span><span class="str">"_fields"</span><span class="op">]</span><span class="op">.</span><span class="nam">append</span><span class="op">(</span><span class="nam">k</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t126" class="stm run hide_run">                <span class="nam">v</span><span class="op">(</span><span class="nam">k</span><span class="op">,</span> <span class="nam">d</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t127" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t128" class="stm run hide_run">        <span class="nam">d</span><span class="op">[</span><span class="str">"_fields"</span><span class="op">]</span><span class="op">.</span><span class="nam">sort</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t129" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t130" class="stm run hide_run">        <span class="key">def</span> <span class="nam">_fields_repr</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t131" class="stm mis">            <span class="key">return</span> <span class="str">" "</span><span class="op">.</span><span class="nam">join</span><span class="op">(</span> <span class="str">"%s:%s"</span> <span class="op">%</span> <span class="op">(</span><span class="nam">f</span><span class="op">,</span> <span class="nam">repr</span><span class="op">(</span><span class="nam">getattr</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">f</span><span class="op">)</span><span class="op">)</span><span class="op">)</span> <span class="key">for</span> <span class="nam">f</span> <span class="key">in</span> <span class="nam">self</span><span class="op">.</span><span class="nam">_fields</span> <span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t132" class="stm run hide_run">        <span class="key">def</span> <span class="nam">__repr__</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t133" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t134" class="stm mis">            <span class="key">return</span> <span class="str">"&lt;%(name)s %(fields)s \nchild:%(r_child)s>"</span> <span class="op">%</span> <span class="op">{</span><span class="strut">&nbsp;</span></p>
<p id="t135" class="pln">                <span class="str">"name"</span><span class="op">:</span> <span class="nam">name</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t136" class="pln">                <span class="str">"fields"</span><span class="op">:</span> <span class="nam">self</span><span class="op">.</span><span class="nam">_fields_repr</span><span class="op">(</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t137" class="pln">                <span class="str">"r_child"</span><span class="op">:</span> <span class="nam">repr</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">child</span><span class="op">(</span><span class="op">)</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t138" class="pln">            <span class="op">}</span><span class="strut">&nbsp;</span></p>
<p id="t139" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t140" class="stm run hide_run">        <span class="nam">d</span><span class="op">[</span><span class="str">"_fields_repr"</span><span class="op">]</span> <span class="op">=</span> <span class="nam">_fields_repr</span><span class="strut">&nbsp;</span></p>
<p id="t141" class="stm run hide_run">        <span class="nam">d</span><span class="op">[</span><span class="str">"__repr__"</span><span class="op">]</span> <span class="op">=</span> <span class="nam">__repr__</span><span class="strut">&nbsp;</span></p>
<p id="t142" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t143" class="stm run hide_run">        <span class="key">return</span> <span class="nam">type</span><span class="op">.</span><span class="nam">__new__</span><span class="op">(</span><span class="nam">cls</span><span class="op">,</span> <span class="nam">name</span><span class="op">,</span> <span class="nam">bases</span><span class="op">,</span> <span class="nam">d</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t144" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t145" class="stm run hide_run"><span class="op">@</span><span class="nam">add_metaclass</span><span class="op">(</span><span class="nam">ProtocolPacketMetaklass</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t146" class="stm run hide_run"><span class="key">class</span> <span class="nam">ProtocolPacket</span><span class="op">(</span><span class="nam">ip</span><span class="op">.</span><span class="nam">ProtocolPacket</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t147" class="stm run hide_run">    <span class="key">def</span> <span class="nam">__init__</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">buff</span> <span class="op">=</span> <span class="key">None</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t148" class="stm run hide_run">        <span class="nam">ip</span><span class="op">.</span><span class="nam">ProtocolPacket</span><span class="op">.</span><span class="nam">__init__</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">self</span><span class="op">.</span><span class="nam">header_size</span><span class="op">,</span> <span class="nam">self</span><span class="op">.</span><span class="nam">tail_size</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t149" class="stm run hide_run">        <span class="key">if</span> <span class="nam">buff</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t150" class="stm run hide_run">            <span class="nam">self</span><span class="op">.</span><span class="nam">load_packet</span><span class="op">(</span><span class="nam">buff</span><span class="op">)</span><span class="strut">&nbsp;</span></p>

            </td>
        </tr>
    </table>
</div>

<div id="footer">
    <div class="content">
        <p>
            <a class="nav" href="index.html">&#xab; index</a> &nbsp; &nbsp; <a class="nav" href="https://coverage.readthedocs.io">coverage.py v4.5.4</a>,
            created at 2019-09-25 12:47
        </p>
    </div>
</div>

</body>
</html>
